//FUNCIN NUEVA EN ESTA VERSIN:PUEDEN ENVIARSE COMANDOS DESDE CUALQUIER CELULAR CON CUALQUIER CLAVE LADA. EN PROGRAMAS ANTERIORES
//SOLAMENTE PODAN ENVIARSE COMANDOS DE USUARIOS CON LADA 55.
//EL SISTEMA EB88 SE ENCUENTRA CONECTADO AL MDEM WAVECOM M1306B A TRAVS DEL PUERTO SERIAL.EL PASSWORD EN ESTE CASO ES "WAV "
//PUEDE RECIBIR CUALQUIERA DE ENTRE 3 COMANDOS DE CUALQUIER MVIL: "WAV R1" PARA ACTIVAR EL RELEVADOR Y "WAV R0" PARA DESACTIVARLO. 
//DESPUS DE EJECUTAR EL COMANDO, EL SISTEMA EB88 ENVA UN MENSAJE DE CONFIRMACIN AL USUARIO: "RELEVADOR ACTIVO"  "RELEVADOR INACTIVO" 
//SI EL MVIL ENVA EL COMANDO "WAV ST", ENTONCES RESPONDE CON EL STATUS DEL SISTEMA POR EJEMPLO: "USER OK RELEVADOR ACTIVO PUERTA ABIERTA".
//SI EL PASSWORD DEL MENSAJE ES INCORRECTO, EL SISTEMA EB88 ANALIZA EL MENSAJE PERO NO REALIZA NINGUNA ACCIN.
//AL DAR RESET AL EB88, EL PROGRAMA INICIA MOSTRANDO EN EL LCD EL TELFONO DEL LTIMO MVIL QUE ENVI UN COMANDO VLIDO.
//EL PASSWORD PUEDE CAMBIARSE EN EL ARREGLO "PASS[5]" Y COMPILANDO Y RECARGANDO EN EL EB88 DE NUEVO EL PROGRAMA EJECUTABLE. 
//EL PROGRAMA TAMBIN DETECTA UNA ALARMA A TRAVS DEL BIT RA4. PARA ACTIVAR ESTA FUNCIN, DEBE CONECTARSE UNA TARJETA DE 
//INTERFAZ CON OPTOACOPLAMIENTO EN EL PUERTO AUXILIAR DEL EB88. SI DETECTA LA ALARMA ACTIVA, ENVA AUTOMTICAMENTE UN MENSAJE SMS AL 
//USUARIO:"PUERTA ABIERTA". HAY EN EL PROGRAMA 2 FLAGS  BANDERAS QUE SON: EN LA LOCALIDAD 10 DE EEPROM SE ALMACENA EL VALOR 106 PARA 
//INDICAR QUE YA EXISTE UN USUARIO AUTORIZADO. EN LA LOCALIDAD 11 DE EEPROM SE ALMACENA EL VALOR 106 PARA INDICAR QUE LA PUERTA YA FUE
//DETECTADA ANTERIORMENTE COMO ABIERTA. STO EVITA QUE LA ALARMA SE EST ACTIVANDO EN FORMA CONSTANTE SI LA PUERTA PERMANECE ABIERTA Y 
//EL SISTEMA EB88 EST ENVIANDO MENSAJES SMS UNA Y OTRA VEZ. ESTE PROGRAMA SOLAMENTE FUNCIONA PARA USUARIOS CON CLAVES LADA 55.LA CLAVE
//LADA PUEDE MODIFICARSE EN LAS LNEAS DE LA FUNCIN CMGS1() Y SOLAMENTE ES NECESARIO CAMBIAR LOS DOS PRIMEROS DGITOS.DEBE COMPILARSE
//DE NUEVO EL PROGRAMA Y CARGARSE EN EL SISTEMA EB88.
//***************PRUEBA SATISFACTORIA****************************************************************************************************

#if defined(__PCM__)
#include "16F88ADC.h"	//archivo header del microcontrolador
#include "keyADC.h"	//librera de LCD, teclado, delay y ADC
#use rs232(baud=9600,xmit=PIN_B5,rcv=PIN_B2)
 
#rom 0X0000={0X018A,0X2803}	//DATOS REQUERIDOS POR TINY					
#build(reset=0x0006)//***IMPORTANTE: CAMBIANDO EL DATO DE 0X0003 A 0X0006 EL COMPILADOR FUNCIONA MUY BIEN

void atwrite(void);
void clearbuffer(void);
void cleararray(void);
void lee_telefono(void);
void read_phoneLCD(void);
char timed_getc(int a);
void at(void);
void CSQ(void);				
void CREG(void);
void CMGF(void);
void CMGD(void);
void CMGL(void);
void CMGS1(int h);
void stringwave(int h);						//funcin para recibir respuesta del mdem. Se usa como argumento el ltimo caracter
										//que se desee almacenar en el arreglo arraywave[]. Se usa junto con la variable global LENWAVE
void starwave(void);					//funcin para esperar la confirmacin del mensaje enviado
void activa_puerto_serial(void);
void desactiva_puerto_serial(void);
int LEN;
signed int z;								//variable almacena la longitud del comando
int LENWAVE;
char a,r,x,y;
char PASS[5]="WAV ";							//PASSWORD: 4 CARACTERES: W,A,V, <ESPACIO>
char arraywave[70];						//arreglo para guardar la cadena de caracteres de la respuesta del mdem.
	
	void main() 
	{
	cleararray();					//borra el arreglo arraywave[]
	desactiva_puerto_serial();
	RA0=0;
	z=read_eeprom(10);				//lee flag de usuario autorizado***
		if(z==106)
		{
		lee_telefono();				//lee el telfono del usuario autorizado, lo almacena en el arreglo arraywave[]
		clearLCD();
		putLCD("USER: ");
		putLCD(read_eeprom(8));
		putLCD(read_eeprom(9));		//muestra la clave LADA
		cursorXY(1,0);
		stringLCD(arraywave);		//muestra en LCD el telfono del cual se envi el ltimo comando.
		delay_ms(2000);
		}
		else
		{
		clearLCD();
		putLCD("NO HAY");
		cursorXY(1,0);
		putLCD("USUARIO");	
		delay_ms(2000);
		}
loop:
	atwrite();						//escribe "AT" en el LCD
	activa_puerto_serial();
	at();							//enva el comando AT, confirma OK
	delay_ms(1000);
	CSQ();								//ENVA COMANDO AT+CSQ
	stringwave(',');					//recibe string hasta que encuentres la coma
	delay_ms(200);
	desactiva_puerto_serial();
	clearLCD();
		for(a=4;a<LENWAVE;a++)
		{
		putLCD(arraywave[a]);				//escribe en LCD respuesta del mdem
		}
	delay_ms(2000);
	activa_puerto_serial();
	CREG();						//enva comando AT+CREG?
	stringwave('K');					//recibe respuesta, llena el arreglo hasta recibir una "K"
	delay_ms(200);
	desactiva_puerto_serial();
	clearLCD();
		for(a=5;a<LENWAVE-3;a++)
		{
		putLCD(arraywave[a]);				//escribe en LCD respuesta del mdem
		}
	delay_ms(2000);
		if(arraywave[12]=='1')
		{
		clearLCD();
		putLCD("MODEM");
		cursorXY(1,0);
		putLCD("GSM OK");
		delay_ms(2000);
		}
		else
		{
		clearLCD();
		putLCD("MODEM");
		cursorXY(1,0);
		putLCD("GSM OFF");
		delay_ms(2000);
		goto loop;						//MDEM NO CONECTADO A LA RED GSM, REPITE INICIALIZACIN.
		}
	activa_puerto_serial();
	CMGF();								//enva comando AT+CMGF? VERIFICA MDEM EN MODO TEXTO
	stringwave('K');					//recibe respuesta, llena el arreglo hasta recibir una "K"
	delay_ms(200);
	desactiva_puerto_serial();
	clearLCD();
		for(a=3;a<LENWAVE-2;a++)
		{
		putLCD(arraywave[a]);				//escribe en LCD respuesta del mdem
		}
	delay_ms(2000);
	clearbuffer();							//borra los mensajes de entrada que estn en el buffer de mensajes SMS del mdem.
	clearbuffer();							//asegura que no exista ningn mensaje en el buffer.
	
//***************INICIO MALLA PRINCIPAL DEL PROGRAMA. ESPERA MENSAJE SMS, LEE SEAL DE ALARMA****************************************
mallachica:
	clearLCD();
		if(RA4==1)
		{
		z=read_eeprom(11);							//lee bandera de puerta abierta. z=0, puerta cerrada; z=106, puerta abierta.
			if(z==0)								//verifica que anteriormente la puerta haya estado cerrada.
			{
			write_eeprom(11,106);						//guarda un 106 en la localidad 11, que es la bandera de que puerta se detect abierta***		
			putLCD("ALARMA");
			CursorXY(1,0);
			putLCD("ACTIVA");
			delay_ms(2000);
			activa_puerto_serial();
			r=3;
			CMGS1(r);								//ENVA EL MENSAJE AL TELFONO AUTORIZADO. EL ARGUMENTO (r) DE LA FUNCIN
			cleararray();							//LIMPIA ARREGLO BUFFER arraywave[],DE RECEPCIN DE CARACTERES DEL MDEM
			starwave();								//ESPERA LA RESPUESTA DE CONFIRMACIN DE MENSAJE ENVIADO: "CMGS=1"
			delay_ms(200);
			desactiva_puerto_serial();
			clearLCD();
			putLCD("SENT>>");
			cursorXY(1,0);
				for(a=0;a<8;a++)
				{
				putLCD(arraywave[a]);				//escribe en LCD confirmacin del mdem: "CMGS: 1"					
				}
			delay_ms(4000);	
			}		
		}
		else
		{
		write_eeprom(11,0);						//guarda un 0 en la localidad 11, que es la bandera de que puerta se detect cerrada***.		
		}
	clearLCD();
	putLCD("WAIT>>>");
	delay_ms(2000);							
	activa_puerto_serial();
	cleararray();							//borra buffer arraywave[]	
	CMGL();									//enva comando: AT+CMGL="ALL"
	stringwave('K');					//recibe respuesta, llena el arreglo arraywave[] hasta recibir una "K"
	delay_ms(200);
	desactiva_puerto_serial();
	cursorXY(1,0);
		for(a=3;a<11;a++)
		{
		putLCD(arraywave[a]);				//escribe en LCD respuesta del mdem
		}
	delay_ms(2000);
		if(arraywave[10]=='1')				//verifica si hay un mensaje pendiente
		{
		clearLCD();
		putLCD("RECIBIDO");					//CONFIRMA QUE EL MENSAJE YA FUE RECIBIDO
		delay_ms(2000);
			if(arraywave[17]=='U')				//SI EL MENSAJE ESTA MARCADO COMO "UNREAD"
			{
			z=0;
			}
			else
			{
			z=-2;								//SI EL MENSAJE EST MARCADO COMO "READ"
			}
			clearLCD();
			putLCD("TEL:  ");
			putLCD(arraywave[26+z]);				//****
			putLCD(arraywave[27+z]);				//****LINEAS NUEVAS MUESTRA CLAVE LADA EN LCD			
			cursorXY(1,0);
				for(a=28+z;a<36+z;a++)
				{
				putLCD(arraywave[a]);				//escribe en LCD el telfono del usuario
				}
			delay_ms(4000);
			clearLCD();
			putLCD("PASS:");
			cursorXY(1,0);
				for(a=63+z;a<69+z;a++)
				{
				putLCD(arraywave[a]);				//escribe en LCD el mensaje, 6 caracteres incluye password y comando
				}
			delay_ms(4000);
				if(PASS[0]==arraywave[63+z]&&PASS[1]==arraywave[64+z]&&PASS[2]==arraywave[65+z]&&PASS[3]==arraywave[66+z])
				{
				cursorXY(1,0);
				putLCD("++OK++");								//PASSWORD CORRECTO
				delay_ms(2000);
					for(a=28+z;a<36+z;a++)							//for(a=26;a<34;a++)
					{
					write_eeprom((a-(28+z)),arraywave[a]);		//guarda en EEPROM el telfono autorizado, en las localidades 0 a 7												
					}
				write_eeprom(8,arraywave[26+z]);
				write_eeprom(9,arraywave[27+z]);			//***LINEA NUEVA guarda clave LADA en localidades 8 y 9 de eeprom.
				write_eeprom(10,106);						//guarda un 106 en la localidad 10, que es la bandera de que ya existe un usuario autorizado***															
				cursorXY(1,0);
				putLCD("GUARDA");							//muestra en el LCD que ya guard el telfono en EEPROM
				delay_ms(2000);
				read_phoneLCD();							//muestra en LCD el telfono del usuario
					if((arraywave[67+z]!='R')||(arraywave[68+z]!='0')||(arraywave[68+z]!='1')){r=2;} //PASSWORD CORRECTO, PERO COMANDO INCORRECTO.
					if(arraywave[67+z]=='R'&&arraywave[68+z]=='0'){RA0=0;r=0;}    //DESACTIVA EL RELEVADOR
					if(arraywave[67+z]=='R'&&arraywave[68+z]=='1'){RA0=1;r=1;}	//ACTIVA EL RELEVADOR					

				clearbuffer();							//borra el buffer arraywave[], que es en donde se almacenan los mensajes provenientes del mvil
				clearLCD();
				putLCD("ENVIANDO");
				delay_ms(2000);
				activa_puerto_serial();
				CMGS1(r);								//ENVA EL MENSAJE AL TELFONO AUTORIZADO. EL ARGUMENTO (r) DE LA FUNCIN ES EL ESTADO DEL RELEVADOR
				cleararray();							//LIMPIA BUFFER DE RECEPCIN DE CARACTERES DEL MDEM
				starwave();								//ESPERA LA RESPUESTA DE CONFIRMACIN DE MENSAJE ENVIADO: "CMGS=1"
				delay_ms(200);
				desactiva_puerto_serial();
				clearLCD();
				putLCD("SENT>>");
				cursorXY(1,0);
					for(a=0;a<8;a++)
					{
					putLCD(arraywave[a]);				//escribe en LCD confirmacin del mdem: "CMGS: 1"					
					}
				delay_ms(4000);	
				}
				else
				{
				cursorXY(1,0);							//PASSWORD INCORRECTO
				putLCD("++NOK++");
				delay_ms(2000);
				clearbuffer();							//borra el mensaje del buffer del mdem.
				}
		}
	delay_ms(200);
	desactiva_puerto_serial();
	goto mallachica;
	}
//***************FINAL DE LA MALLA PRINCIPAL DEL PROGRAMA. ESPERA MENSAJE SMS, LEE SEAL DE ALARMA*************************************
	void activa_puerto_serial(void)
	{
	SPEN=1;
	CREN=0;								//PREPARA ACTIVACION DEL PUERTO SERIAL
	CREN=1;								//EXPRESIONES NECESARIAS PARA VOLVER
	z=RCREG;							//A USAR EL PUERTO. LA VARIABLE z DEBE
	z=RCREG;							//DEFINIRSE PREVIAMENTE Y SOLO SIRVE PARA
	z=RCREG;							//DESCARGAR EL BUFFER DE RECEPCION RCREG
	TRISB=0XFF;
	}

	void desactiva_puerto_serial(void)
	{
	SPEN=0;									//desactiva puerto serial
	TRISA=0X10;								//activa LCD, RA4 ES ENTRADA DE ALARMA
	TRISB=0;
	}


void CSQ(void)					//funcin enva
{
	char comwave[]="AT+CSQ";
	int aa;
	delay_ms(500);
	putchar(65);						//enva "A"
malla2:
	x=getchar();
	if(x!=65)goto malla2;				//espera el eco de la "A".
	putchar(84);						//enva "T"
	x=getchar();						//lee el eco de "T"
	LEN=6;						//almacena longitud del string
		for(aa=2;aa<LEN;aa++)
		{
		putchar(comwave[aa]);				//enva caracter
		x=getchar();					//recibe el eco
		}
		putchar(13);					//manda el CR
}

void CREG(void)					//funcin enva comando para conocer si ya est enlazado en la red GSM
{
	char comwave[]="AT+CREG?";
	int aa;
	delay_ms(500);
	putchar(65);						//enva "A"
malla2:
	x=getchar();
	if(x!=65)goto malla2;				//espera el eco de la "A".
	putchar(84);						//enva "T"
	x=getchar();						//lee el eco de "T"
	LEN=8;								//almacena longitud del string
		for(aa=2;aa<LEN;aa++)
		{
		putchar(comwave[aa]);				//enva caracter
		x=getchar();					//recibe el eco
		}
		putchar(13);					//manda el CR
}

void CMGF(void)							//funcin verifica que mdem est en modo texto.
{
	char comwave[]="AT+CMGF?";
	int aa;
	delay_ms(500);
	putchar(65);						//enva "A"
malla2:
	x=getchar();
	if(x!=65)goto malla2;				//espera el eco de la "A".
	putchar(84);						//enva "T"
	x=getchar();						//lee el eco de "T"
	LEN=8;								//almacena longitud del string
		for(aa=2;aa<LEN;aa++)
		{
		putchar(comwave[aa]);				//enva caracter
		x=getchar();					//recibe el eco
		}
		putchar(13);					//manda el CR
}

void CMGD(void)							//COMANDO VACA EL BUFFER DEL MDEM DE MENSAJES SMS.
{
	char comwave[]="AT+CMGD=1,1";
	int aa;
	delay_ms(500);
	putchar(65);						//enva "A"
malla2:
	x=getchar();
	if(x!=65)goto malla2;				//espera el eco de la "A".
	putchar(84);						//enva "T"
	x=getchar();						//lee el eco de "T"
	LEN=11;						//almacena longitud del string
		for(aa=2;aa<LEN;aa++)
		{
		putchar(comwave[aa]);				//enva caracter
		x=getchar();					//recibe el eco
		}
		putchar(13);					//manda el CR
}

void CMGL(void)							//comando interroga al mdem para ver si hay algn mensaje.
{
	char comwave[]={65,84,43,67,77,71,76,61,34,65,76,76,34,0};		//define string "AT+CMGL="ALL"
	int aa;
	delay_ms(500);
	putchar(65);						//enva "A"
malla2:
	x=timed_getc('A');
	if(x!=65)goto malla2;				//espera el eco de la "A".
	putchar(84);						//enva "T"
	x=timed_getc('T');						//lee el eco de "T"
	LEN=13;						//almacena longitud del string
		for(aa=2;aa<LEN;aa++)
		{
		putchar(comwave[aa]);				//enva caracter
		x=timed_getc('A');;					//recibe el eco
		}
		putchar(13);					//manda el CR
}

void stringwave(int h)					//recibe cadena de respuesta del mdem hasta que encuentre el caracter dado 
										//en el argumento entre parntesis al llamar a la funcin.
{
	LENWAVE=0;
	while(1)
	{arraywave[LENWAVE]=timed_getc('K');
	if(arraywave[LENWAVE]==h)			//lee caracteres hasta detectar el argumento
		{
		goto forward;					
		}
	LENWAVE++;
	if(LENWAVE>68)goto forward;
	}
forward:
	a=a;
}


void at(void)							//enva comando base: "AT",y confirma que recibe "OK"
{
	delay_ms(300);
	putchar(65);							//"A"
malla1:
	x=getchar();
	if(x!=65)goto malla1;				//espera el eco de la "A".
	putchar(84);						//"T"
	x=getchar();						//lee eco de la "T"
	putchar(13);						//CR
	a=0;
		while(1)
		{arraywave[a]=getchar();
		if(arraywave[a]==75)goto sigue;			//lee caracteres hasta detectar la "K"
		a++;
		}
sigue:									
	desactiva_puerto_serial();			//escribe en el LCD los caracteres recibidos, en este caso "OK".
	cursorXY(1,0);
	putLCD(arraywave[3]);
	putLCD(arraywave[4]);
	activa_puerto_serial();
}

void atwrite(void)						//escribe "AT" en LCD
{
	desactiva_puerto_serial();
	initLCD( );
	clearLCD();
	PutLCD("AT");
	delay_ms(300);
	activa_puerto_serial();
	delay_ms(300);
}

char timed_getc(int a) 					//equivalente a getchar(), pero con timeout de 100 milisegundos.
{										//si se vence el timeout, la subrutina regresa con el caracter del argumento int a
long timeout;
timeout=0;
while(!kbhit()&&(++timeout<21000))   // 100 milisegundos
delay_us(10);
if(kbhit())								//hay caracter en buffer?
return(getc());
	else 
	{   
	return(a);
	}
}

void cleararray(void)					//llena del caracter espacio [20H] el arreglo "arraywave[]"
{
	for(a=0;a<70;a++)
	{
	arraywave[a]=32;
	}
}

void clearbuffer(void)						//borra los mensajes de entrada que estn en el buffer de mensajes del mdem.
{
	delay_ms(2000);
	activa_puerto_serial();
	CMGD();									//enva "AT+CMGD=1,1" para borrar el buffer de mensajes SMS
	delay_ms(200);
	desactiva_puerto_serial();
	clearLCD();
	putLCD("BUFFER:");
	delay_ms(2000);							//espera para dar tiempo a vaciar el buffer, si es que tiene muchos mensajes.
	activa_puerto_serial();
	CMGL();									//comando verifica que el buffer est vaco.
	stringwave('K');						//recibe respuesta, llena el arreglo hasta recibir una "K"
	delay_ms(200);
	desactiva_puerto_serial();
	cursorXY(1,0);
		for(a=3;a<LENWAVE+1;a++)
		{
		putLCD(arraywave[a]);				//escribe en LCD respuesta del mdem
		}
	delay_ms(2000);
}

void lee_telefono(void)
{
char a;
	for(a=0;a<8;a++)
	{
	arraywave[a]=read_eeprom(a);			//lee telfono autorizado de la eeprom lo almacena en el arreglo arraywave[]
	arraywave[8]=0;										//son 8 dgitos, no incluye clave lada. Termina string con caracter NULL
	}
}	

void read_phoneLCD(void)					//lee eeprom y escribe en LCD el telfono autorizado
{
	for(a=0;a<8;a++)
	{
	arraywave[a]=read_eeprom(a);			//lee telfono autorizado de la eeprom
	arraywave[8]=0;							//terminacin de string
	}
	delay_ms(200);
	desactiva_puerto_serial();
	clearLCD();
	putLCD("USER: ");
	putLCD(read_eeprom(8));
	putLCD(read_eeprom(9));					//muestra clave LADA leda de la EEPROM en LCD
	cursorXY(1,0);
	stringLCD(arraywave);					//escribe el telfono autorizado en LCD
	delay_ms(2000);							
}
											//ENVA MENSAJES DE CONFIRMACIN AL USUARIO CON COMANDO DE FORMATO: "AT+CMGS=5521806666..."
											//EL ARGUMENTO DE LA FUNCIN DETERMINA EL MENSAJE QUE SE ENVIAR
void CMGS1(int h)							
{
	int aa;
	char comwave[]={65,84,43,67,77,71,83,61,34,20,20,20,20,20,20,20,20,20,20,34,0};		//define string <AT+CMGS="        ">
	const char comwave100[]="RELEVADOR INACTIVO ";
	const char comwave101[]="RELEVADOR ACTIVO ";
	const char comwave102[]="USER OK ";
	const char comwave103[]="PUERTA ABIERTA";
	const char comwave104[]="PUERTA CERRADA";
	lee_telefono();
		for(aa=0;aa<8;aa++)
		{
		comwave[aa+11]=arraywave[aa];			//acomoda el telefono sin cdigo lada en el arreglo
		}
	comwave[9]=read_eeprom(8);
	comwave[10]=read_eeprom(9);							//acomoda el cdigo lada en el arreglo 
	delay_ms(500);
	putchar(65);						//enva "A"
malla8:
	x=getchar();
	if(x!=65)goto malla8;				//espera el eco de la "A".
	putchar(84);						//enva "T"
	x=getchar();						//lee el eco de "T"
	LEN=20;						//almacena longitud del string
		for(aa=2;aa<LEN;aa++)
		{
		putchar(comwave[aa]);				//enva caracter
		x=getchar();					//recibe el eco
		}
	putchar(13);					//manda el CR
malla9:
	x=getchar();
	if(x!=62)goto malla9;				//espera el promt ">".
		if(h==0)
		{
		LEN=18;										//"RELEVADOR INACTIVO"
			for(aa=0;aa<LEN;aa++)
			{										//EN ESTA MALLA SE ENVA EL MENSAJE DEL ARREGLO comwave100[]
			putchar(comwave100[aa]);				//manda caracter al mdem
			x=getchar();					//recibe el eco
			}
		putchar(26);							//manda <CTRL Z>
		}
		
		if(h==1)
		{
		LEN=16;										//"RELEVADOR ACTIVO"
			for(aa=0;aa<LEN;aa++)
			{										//EN ESTA MALLA SE ENVA EL MENSAJE DEL ARREGLO comwave101[]
			putchar(comwave101[aa]);				//manda caracter al mdem
			x=getchar();					//recibe el eco
			}
		putchar(26);							//manda <CTRL Z>	
		}
//*******************************************************ENVO DEL STATUS DEL SISTEMA***********************************************
		if(h==2)							
		{
		LEN=8;									//"USER OK "
			for(aa=0;aa<LEN;aa++)
			{										//EN ESTA MALLA SE ENVA EL MENSAJE DEL ARREGLO comwave102[]
			putchar(comwave102[aa]);				//manda caracter al mdem
			x=getchar();					//recibe el eco
			}
			if(RA0==1)
			{
			LEN=17;										//"RELEVADOR ACTIVO "
				for(aa=0;aa<LEN;aa++)
				{										//EN ESTA MALLA SE ENVA EL MENSAJE DEL ARREGLO comwave101[]
				putchar(comwave101[aa]);				//manda caracter al mdem
				x=getchar();						//recibe el eco
				}
			}
			else
			{
			LEN=19;										//"RELEVADOR INACTIVO "
				for(aa=0;aa<LEN;aa++)
				{										//EN ESTA MALLA SE ENVA EL MENSAJE DEL ARREGLO comwave101[]
				putchar(comwave100[aa]);				//manda caracter al mdem
				x=getchar();						//recibe el eco
				}
			}
			if(RA4==1)
			{
			LEN=14;										//"ALARMA ACTIVA"
				for(aa=0;aa<LEN;aa++)
				{										//EN ESTA MALLA SE ENVA EL MENSAJE DEL ARREGLO comwave101[]
				putchar(comwave103[aa]);				//manda caracter al mdem
				x=getchar();						//recibe el eco
				}
			}
			else
			{
			LEN=14;										//"PUERTA CERRADA"
				for(aa=0;aa<LEN;aa++)
				{										//EN ESTA MALLA SE ENVA EL MENSAJE DEL ARREGLO comwave101[]
				putchar(comwave104[aa]);				//manda caracter al mdem
				x=getchar();						//recibe el eco
				}
			}		
		putchar(26);							//manda <CTRL Z>	
		}
//**************************************************FIN DE ENVO DEL STATUS DEL SISTEMA*****************************************************
		if(h==3)
		{
		LEN=14;									//PUERTA ABIERTA
			for(aa=0;aa<LEN;aa++)
			{										//EN ESTA MALLA SE ENVA EL MENSAJE DEL ARREGLO comwave103[]
			putchar(comwave103[aa]);				//manda caracter al mdem
			x=getchar();					//recibe el eco
			}
		putchar(26);							//manda <CTRL Z>	
		}
}

void starwave (void)				//espera confirmacin de la red GSM y el mdem de que el mensaje fu enviado: "+CMGS 1"
{
int a;
malla20:
	x=getchar();						//***ESTA FUNCIN PODRA CAMBIARSE A "timed_getc(int a)" PARA EVITAR QUE QUEDE ATRAPADO EL PROGRAMA
										//***EN CASO DE QUE EL MDEM NO RECIBA LA CONFIRMACIN DE MENSAJE ENVIADO DE LA RED GSM.
	if(x!=43)goto malla20;				//espera el caracter "+".
	LEN=7;								//almacena longitud del string
		for(a=0;a<LEN;a++)
		{
		arraywave[a]=getchar();					//recibe mensaje
		}
}												